{-
  A fractal called the Koch line.  Three Koch lines arranged into an
  equilateral triangle are called a Koch snowflake.
-}

import CodeWorld

main = displayInCanvas (scale 0.8 0.8 (kochSnowflake 5))

kochSnowflake n = pictures [
    translate (   0) (145) (rotate   0 (kochLine n)),
    translate (-125) (-72) (rotate 120 (kochLine n)),
    translate ( 125) (-72) (rotate 240 (kochLine n))
    ]

kochLine 0 = line [(-250, 0), (250, 0)]
kochLine n = pictures [
    translate (-167)  0 (rotate (  0) subline),
    translate ( -42) 72 (rotate ( 60) subline),
    translate (  42) 72 (rotate (-60) subline),
    translate ( 167)  0 (rotate (  0) subline)
    ]
    where subline = scale (1/3) (1/3) (kochLine (n-1))

